package android.support.multidex;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.content.pm.ApplicationInfo;
import android.os.Build.VERSION;
import android.util.Log;
import java.io.BufferedOutputStream;
import java.io.Closeable;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipException;
import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;

final class e
{
  private static Method a;
  
  static
  {
    try
    {
      a = SharedPreferences.Editor.class.getMethod("apply", new Class[0]);
      return;
    }
    catch (NoSuchMethodException localNoSuchMethodException)
    {
      for (;;)
      {
        a = null;
      }
    }
  }
  
  private static SharedPreferences a(Context paramContext)
  {
    if (Build.VERSION.SDK_INT < 11) {}
    for (int i = 0;; i = 4) {
      return paramContext.getSharedPreferences("multidex.version", i);
    }
  }
  
  static List<File> a(Context paramContext, ApplicationInfo paramApplicationInfo, File paramFile, boolean paramBoolean)
  {
    Log.i("MultiDex", "MultiDexExtractor.load(" + paramApplicationInfo.sourceDir + ", " + paramBoolean + ")");
    File localFile = new File(paramApplicationInfo.sourceDir);
    long l = c(localFile);
    if ((!paramBoolean) && (!a(paramContext, localFile, l))) {}
    for (;;)
    {
      try
      {
        paramApplicationInfo = a(paramContext, localFile, paramFile);
        paramContext = paramApplicationInfo;
      }
      catch (IOException paramApplicationInfo)
      {
        Log.w("MultiDex", "Failed to reload existing extracted secondary dex files, falling back to fresh extraction", paramApplicationInfo);
        paramApplicationInfo = a(localFile, paramFile);
        a(paramContext, b(localFile), l, paramApplicationInfo.size() + 1);
        paramContext = paramApplicationInfo;
        continue;
      }
      Log.i("MultiDex", "load found " + paramContext.size() + " secondary dex files");
      return paramContext;
      Log.i("MultiDex", "Detected that extraction must be performed.");
      paramApplicationInfo = a(localFile, paramFile);
      a(paramContext, b(localFile), l, paramApplicationInfo.size() + 1);
      paramContext = paramApplicationInfo;
    }
  }
  
  private static List<File> a(Context paramContext, File paramFile1, File paramFile2)
  {
    Log.i("MultiDex", "loading existing secondary dex files");
    paramFile1 = paramFile1.getName() + ".classes";
    int j = a(paramContext).getInt("dex.number", 1);
    ArrayList localArrayList = new ArrayList(j);
    for (int i = 2; i <= j; i++)
    {
      paramContext = new File(paramFile2, paramFile1 + i + ".zip");
      if (paramContext.isFile())
      {
        localArrayList.add(paramContext);
        if (!a(paramContext))
        {
          Log.i("MultiDex", "Invalid zip file: " + paramContext);
          throw new IOException("Invalid ZIP file.");
        }
      }
      else
      {
        throw new IOException("Missing extracted secondary dex file '" + paramContext.getPath() + "'");
      }
    }
    return localArrayList;
  }
  
  private static List<File> a(File paramFile1, File paramFile2)
  {
    String str = paramFile1.getName() + ".classes";
    a(paramFile2, str);
    localArrayList = new ArrayList();
    localZipFile = new ZipFile(paramFile1);
    try
    {
      paramFile1 = new java/lang/StringBuilder;
      paramFile1.<init>();
      paramFile1 = localZipFile.getEntry("classes" + 2 + ".dex");
      j = 2;
    }
    finally
    {
      for (;;)
      {
        try
        {
          int j;
          Object localObject;
          File localFile;
          boolean bool;
          int i;
          StringBuilder localStringBuilder;
          localZipFile.close();
          throw paramFile1;
          j++;
          paramFile1 = new java/lang/StringBuilder;
          paramFile1.<init>();
          paramFile1 = localZipFile.getEntry("classes" + j + ".dex");
          continue;
          try
          {
            localZipFile.close();
            return localArrayList;
          }
          catch (IOException paramFile1)
          {
            Log.w("MultiDex", "Failed to close resource", paramFile1);
          }
        }
        catch (IOException paramFile2)
        {
          Log.w("MultiDex", "Failed to close resource", paramFile2);
        }
      }
    }
    if (paramFile1 != null)
    {
      localObject = new java/lang/StringBuilder;
      ((StringBuilder)localObject).<init>();
      localObject = str + j + ".zip";
      localFile = new java/io/File;
      localFile.<init>(paramFile2, (String)localObject);
      localArrayList.add(localFile);
      localObject = new java/lang/StringBuilder;
      ((StringBuilder)localObject).<init>();
      Log.i("MultiDex", "Extraction is needed for file " + localFile);
      bool = false;
      i = 0;
      if ((i < 3) && (!bool))
      {
        i++;
        a(localZipFile, paramFile1, localFile, str);
        bool = a(localFile);
        localObject = new java/lang/StringBuilder;
        ((StringBuilder)localObject).<init>();
        localStringBuilder = ((StringBuilder)localObject).append("Extraction ");
        if (bool) {}
        for (localObject = "success";; localObject = "failed")
        {
          Log.i("MultiDex", (String)localObject + " - length " + localFile.getAbsolutePath() + ": " + localFile.length());
          if (bool) {
            break label462;
          }
          localFile.delete();
          if (!localFile.exists()) {
            break label462;
          }
          localObject = new java/lang/StringBuilder;
          ((StringBuilder)localObject).<init>();
          Log.w("MultiDex", "Failed to delete corrupted secondary dex '" + localFile.getPath() + "'");
          break;
        }
      }
      if (!bool)
      {
        paramFile2 = new java/io/IOException;
        paramFile1 = new java/lang/StringBuilder;
        paramFile1.<init>();
        paramFile2.<init>("Could not create zip file " + localFile.getAbsolutePath() + " for secondary dex (" + j + ")");
        throw paramFile2;
      }
    }
  }
  
  private static void a(Context paramContext, long paramLong1, long paramLong2, int paramInt)
  {
    paramContext = a(paramContext).edit();
    paramContext.putLong("timestamp", paramLong1);
    paramContext.putLong("crc", paramLong2);
    paramContext.putInt("dex.number", paramInt);
    a(paramContext);
  }
  
  private static void a(SharedPreferences.Editor paramEditor)
  {
    if (a != null) {}
    try
    {
      a.invoke(paramEditor, new Object[0]);
      return;
    }
    catch (IllegalAccessException localIllegalAccessException)
    {
      for (;;)
      {
        paramEditor.commit();
      }
    }
    catch (InvocationTargetException localInvocationTargetException)
    {
      for (;;) {}
    }
  }
  
  private static void a(Closeable paramCloseable)
  {
    try
    {
      paramCloseable.close();
      return;
    }
    catch (IOException paramCloseable)
    {
      for (;;)
      {
        Log.w("MultiDex", "Failed to close resource", paramCloseable);
      }
    }
  }
  
  private static void a(File paramFile, String paramString)
  {
    d(paramFile.getParentFile());
    d(paramFile);
    paramString = paramFile.listFiles(new f(paramString));
    if (paramString == null)
    {
      Log.w("MultiDex", "Failed to list secondary dex dir content (" + paramFile.getPath() + ").");
      return;
    }
    int j = paramString.length;
    int i = 0;
    label69:
    if (i < j)
    {
      paramFile = paramString[i];
      Log.i("MultiDex", "Trying to delete old file " + paramFile.getPath() + " of size " + paramFile.length());
      if (paramFile.delete()) {
        break label162;
      }
      Log.w("MultiDex", "Failed to delete old file " + paramFile.getPath());
    }
    for (;;)
    {
      i++;
      break label69;
      break;
      label162:
      Log.i("MultiDex", "Deleted old file " + paramFile.getPath());
    }
  }
  
  private static void a(ZipFile paramZipFile, ZipEntry paramZipEntry, File paramFile, String paramString)
  {
    paramZipFile = paramZipFile.getInputStream(paramZipEntry);
    paramString = File.createTempFile(paramString, ".zip", paramFile.getParentFile());
    Log.i("MultiDex", "Extracting " + paramString.getPath());
    try
    {
      Object localObject1 = new java/util/zip/ZipOutputStream;
      BufferedOutputStream localBufferedOutputStream = new java/io/BufferedOutputStream;
      Object localObject2 = new java/io/FileOutputStream;
      ((FileOutputStream)localObject2).<init>(paramString);
      localBufferedOutputStream.<init>((OutputStream)localObject2);
      ((ZipOutputStream)localObject1).<init>(localBufferedOutputStream);
      int i;
      a(paramZipFile);
    }
    finally
    {
      try
      {
        localObject2 = new java/util/zip/ZipEntry;
        ((ZipEntry)localObject2).<init>("classes.dex");
        ((ZipEntry)localObject2).setTime(paramZipEntry.getTime());
        ((ZipOutputStream)localObject1).putNextEntry((ZipEntry)localObject2);
        paramZipEntry = new byte['䀀'];
        for (i = paramZipFile.read(paramZipEntry); i != -1; i = paramZipFile.read(paramZipEntry)) {
          ((ZipOutputStream)localObject1).write(paramZipEntry, 0, i);
        }
        ((ZipOutputStream)localObject1).closeEntry();
        ((ZipOutputStream)localObject1).close();
        paramZipEntry = new java/lang/StringBuilder;
        paramZipEntry.<init>();
        Log.i("MultiDex", "Renaming to " + paramFile.getPath());
        if (paramString.renameTo(paramFile)) {
          break label274;
        }
        localObject1 = new java/io/IOException;
        paramZipEntry = new java/lang/StringBuilder;
        paramZipEntry.<init>();
        ((IOException)localObject1).<init>("Failed to rename \"" + paramString.getAbsolutePath() + "\" to \"" + paramFile.getAbsolutePath() + "\"");
        throw ((Throwable)localObject1);
      }
      finally
      {
        ((ZipOutputStream)localObject1).close();
      }
      paramZipEntry = finally;
      a(paramZipFile);
      paramString.delete();
    }
    label274:
    paramString.delete();
  }
  
  private static boolean a(Context paramContext, File paramFile, long paramLong)
  {
    paramContext = a(paramContext);
    if ((paramContext.getLong("timestamp", -1L) != b(paramFile)) || (paramContext.getLong("crc", -1L) != paramLong)) {}
    for (boolean bool = true;; bool = false) {
      return bool;
    }
  }
  
  static boolean a(File paramFile)
  {
    for (;;)
    {
      try
      {
        ZipFile localZipFile = new java/util/zip/ZipFile;
        localZipFile.<init>(paramFile);
        try
        {
          localZipFile.close();
          bool = true;
          return bool;
        }
        catch (IOException localIOException1)
        {
          StringBuilder localStringBuilder = new java/lang/StringBuilder;
          localStringBuilder.<init>();
          Log.w("MultiDex", "Failed to close zip file: " + paramFile.getAbsolutePath());
        }
      }
      catch (ZipException localZipException)
      {
        boolean bool;
        Log.w("MultiDex", "File " + paramFile.getAbsolutePath() + " is not a valid zip file.", localZipException);
        continue;
      }
      catch (IOException localIOException2)
      {
        Log.w("MultiDex", "Got an IOException trying to open zip file: " + paramFile.getAbsolutePath(), localIOException2);
        continue;
      }
      bool = false;
    }
  }
  
  private static long b(File paramFile)
  {
    long l2 = paramFile.lastModified();
    long l1 = l2;
    if (l2 == -1L) {
      l1 = l2 - 1L;
    }
    return l1;
  }
  
  private static long c(File paramFile)
  {
    long l2 = g.a(paramFile);
    long l1 = l2;
    if (l2 == -1L) {
      l1 = l2 - 1L;
    }
    return l1;
  }
  
  private static void d(File paramFile)
  {
    paramFile.mkdir();
    if (!paramFile.isDirectory())
    {
      File localFile = paramFile.getParentFile();
      if (localFile == null) {
        Log.e("MultiDex", "Failed to create dir " + paramFile.getPath() + ". Parent file is null.");
      }
      for (;;)
      {
        throw new IOException("Failed to create cache directory " + paramFile.getPath());
        Log.e("MultiDex", "Failed to create dir " + paramFile.getPath() + ". parent file is a dir " + localFile.isDirectory() + ", a file " + localFile.isFile() + ", exists " + localFile.exists() + ", readable " + localFile.canRead() + ", writable " + localFile.canWrite());
      }
    }
  }
}


/* Location:              skip...
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */